package com.smcic.api.operate.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.smcic.api.operate.entity.Operate;
import com.smcic.api.operate.mapper.OperateMapper;
import com.smcic.api.operate.service.IOperateService;
import com.smcic.core.advice.APIException;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.ZoneOffset;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2022-12-10
 */
@Service
public class OperateServiceImpl extends ServiceImpl<OperateMapper, Operate> implements IOperateService {

    public void verify(Integer operateId){
        LocalDateTime now = LocalDateTime.now();
        Operate ope = getById(operateId);

        if(null != ope.getStartTime() && ope.getStartTime().isAfter(now)){
            throw new APIException(400, "活动尚未开始");
        }

        if(null != ope.getEndTime() && ope.getEndTime().isBefore(now)){
            throw new APIException(400, "活动已经结束");
        }

    }

    public Long getTTl(Integer operateId){
        LocalDateTime now = LocalDateTime.now();
        Operate ope = getById(operateId);
        if(null == ope.getEndTime()) return 3600 * 24 * 365L;
        return ope.getEndTime().isAfter(now) ? ope.getEndTime().toEpochSecond(ZoneOffset.of("+8")) - now.toEpochSecond(ZoneOffset.of("+8")) : 1L;
    }
}
